<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanPractice".
 *
 * Columns in table "scan_practice" available as properties of the model,
 * followed by relations of table "scan_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $organization_id
 * @property integer $practice_id
 * @property integer $scan_log_id
 * @property integer $op_score
 * @property string $aggregate_rating
 * @property integer $aggregate_accuracy
 * @property integer $total_reviews
 * @property integer $google_reviews
 * @property integer $yelp_reviews
 * @property integer $website_mobile
 * @property integer $practice_accuracy
 * @property integer $practice_reviews
 * @property integer $missing_listings
 * @property integer $profile_completion_score
 * @property integer $data_elements
 * @property integer $completed_scans
 * @property integer $cnt_errors
 * @property integer $average_provider_accuracy
 * @property integer $average_provider_reviews
 * @property string $reviews_grade
 * @property string $zip
 * @property string $specialty_field
 * @property string $practice_name
 * @property string $address
 * @property string $phone
 * @property string $website
 * @property string $missing_listing_names
 * @property string $profile_completion_missing_data
 * @property string $date_added
 * @property integer $month
 * @property integer $year
 *
 * @property ScanLog $scanLog
 * @property Organization $organization
 * @property Practice $practice
 * @property ScanProvider[] $scanProviders
 */
abstract class BaseScanPractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanPractice|ScanPractices', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('organization_id, practice_id', 'required'),
            array('organization_id, practice_id, scan_log_id, op_score, aggregate_accuracy, total_reviews, '
                . 'google_reviews, yelp_reviews, website_mobile, practice_accuracy, practice_reviews, '
                . 'missing_listings, profile_completion_score, data_elements, completed_scans, cnt_errors, '
                . 'average_provider_accuracy, average_provider_reviews, month, year', 'numerical',
                'integerOnly' => true),
            array('aggregate_rating, reviews_grade', 'length', 'max' => 3),
            array('zip', 'length', 'max' => 5),
            array('specialty_field', 'length', 'max' => 1),
            array('practice_name, address, website', 'length', 'max' => 255),
            array('phone', 'length', 'max' => 32),
            array('missing_listing_names, profile_completion_missing_data, date_added', 'safe'),
            array('op_score, aggregate_rating, aggregate_accuracy, total_reviews, google_reviews, yelp_reviews, '
                . 'website_mobile, practice_accuracy, practice_reviews, completed_scans, data_elements, '
                . 'missing_listings, profile_completion_score, cnt_errors, average_provider_accuracy, '
                . 'average_provider_reviews, reviews_grade, zip, specialty_field, practice_name, address, phone, '
                . 'website, missing_listing_names, profile_completion_missing_data, date_added', 'default',
                'setOnEmpty' => true, 'value' => null),
            array('id, organization_id, practice_id, scan_log_id, op_score, aggregate_rating, aggregate_accuracy, '
                . 'total_reviews, google_reviews, yelp_reviews, website_mobile, practice_accuracy, practice_reviews, '
                . 'missing_listings, profile_completion_score, data_elements, completed_scans, cnt_errors, '
                . 'average_provider_accuracy, average_provider_reviews, reviews_grade, zip, specialty_field, '
                . 'practice_name, address, phone, website, missing_listing_names, profile_completion_missing_data, '
                . 'date_added, month, year', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanLog' => array(self::BELONGS_TO, 'ScanLog', 'scan_log_id'),
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'scanProviders' => array(self::HAS_MANY, 'ScanProvider', 'scan_practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'organization_id' => null,
            'practice_id' => null,
            'scan_log_id' => 'Scan Log',
            'op_score' => Yii::t('app', 'Op Score'),
            'aggregate_rating' => Yii::t('app', 'Aggregate Rating'),
            'aggregate_accuracy' => Yii::t('app', 'Aggregate Accuracy'),
            'total_reviews' => Yii::t('app', 'Total Reviews'),
            'google_reviews' => Yii::t('app', 'Google Reviews'),
            'yelp_reviews' => Yii::t('app', 'Yelp Reviews'),
            'website_mobile' => Yii::t('app', 'Website Mobile'),
            'practice_accuracy' => Yii::t('app', 'Practice Accuracy'),
            'practice_reviews' => Yii::t('app', 'Practice Reviews'),
            'completed_scans' => Yii::t('app', 'Completed Scans'),
            'data_elements' => Yii::t('app', 'Data Elements'),
            'missing_listings' => Yii::t('app', 'Missing Listings'),
            'profile_completion_score' => Yii::t('app', 'Profile Completion Score'),
            'cnt_errors' => Yii::t('app', 'Cnt Errors'),
            'average_provider_accuracy' => Yii::t('app', 'Average Provider Accuracy'),
            'average_provider_reviews' => Yii::t('app', 'Average Provider Reviews'),
            'reviews_grade' => Yii::t('app', 'Reviews Grade'),
            'zip' => Yii::t('app', 'Zip'),
            'specialty_field' => Yii::t('app', 'Specialty Field'),
            'practice_name' => Yii::t('app', 'Practice Name'),
            'address' => Yii::t('app', 'Address'),
            'phone' => Yii::t('app', 'Phone'),
            'website' => Yii::t('app', 'Website'),
            'missing_listing_names' => Yii::t('app', 'Missing Listing Names'),
            'profile_completion_missing_data' => Yii::t('app', 'Profile Completion Missing Data'),
            'date_added' => Yii::t('app', 'Date Added'),
            'month' => 'Month',
            'year' => 'Year',
            'organization' => null,
            'practice' => null,
            'scanProviders' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('scan_log_id', $this->scan_log_id);
        $criteria->compare('op_score', $this->op_score);
        $criteria->compare('aggregate_rating', $this->aggregate_rating, true);
        $criteria->compare('aggregate_accuracy', $this->aggregate_accuracy);
        $criteria->compare('total_reviews', $this->total_reviews);
        $criteria->compare('google_reviews', $this->google_reviews);
        $criteria->compare('yelp_reviews', $this->yelp_reviews);
        $criteria->compare('website_mobile', $this->website_mobile);
        $criteria->compare('practice_accuracy', $this->practice_accuracy);
        $criteria->compare('practice_reviews', $this->practice_reviews);
        $criteria->compare('missing_listings', $this->missing_listings);
        $criteria->compare('profile_completion_score', $this->profile_completion_score);
        $criteria->compare('data_elements', $this->data_elements);
        $criteria->compare('completed_scans', $this->completed_scans);
        $criteria->compare('cnt_errors', $this->cnt_errors);
        $criteria->compare('average_provider_accuracy', $this->average_provider_accuracy);
        $criteria->compare('average_provider_reviews', $this->average_provider_reviews);
        $criteria->compare('reviews_grade', $this->reviews_grade, true);
        $criteria->compare('zip', $this->zip, true);
        $criteria->compare('specialty_field', $this->specialty_field, true);
        $criteria->compare('practice_name', $this->practice_name, true);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('phone', $this->phone, true);
        $criteria->compare('website', $this->website, true);
        $criteria->compare('missing_listing_names', $this->missing_listing_names, true);
        $criteria->compare('profile_completion_missing_data', $this->profile_completion_missing_data, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('month', $this->month);
        $criteria->compare('year', $this->year);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
